=== renamed file 'CodeViewer/DomExample1/DomExample1.htm' => 'CodeViewer/DomExample1/DomExample1.html'
=== modified file 'CodeViewer/DomExample1/DomExample1.php'
--- CodeViewer/DomExample1/DomExample1.php	2013-03-26 23:22:55 +0000
+++ CodeViewer/DomExample1/DomExample1.php	2013-04-19 09:12:11 +0000
@@ -9,7 +9,7 @@
 	include("../Codeviewer/showcode.php");
 
 	
-	menulayout("../DomExample1b/DomExample1b.php","","DomExample1.txt","DOM Example 1: Initiation and simple navigation (click this heading to run code)","DomExample1code.php","DomExample1.htm");
+	menulayout("../DomExample1b/DomExample1b.php","","DomExample1.txt","DOM Example 1: Initiation and simple navigation (click this heading to run code)","DomExample1code.php","DomExample1.html");
 	
 	$interestingrows=array(array(8,10,"PHP Code"),array(12,17,"PHP Code"));
 	$keywords=array('getElementsByTagName','tagName','childNodes','nodeValue','documentElement');

=== renamed file 'CodeViewer/DomExample2/DomExample2.htm' => 'CodeViewer/DomExample2/DomExample2.html'
=== modified file 'CodeViewer/DomExample2/DomExample2.php'
--- CodeViewer/DomExample2/DomExample2.php	2013-03-26 23:22:55 +0000
+++ CodeViewer/DomExample2/DomExample2.php	2013-04-19 09:12:11 +0000
@@ -8,7 +8,7 @@
 
 	include("../Codeviewer/showcode.php");
 	
-	menulayout("../DomExample2b/DomExample2b.php","../DomExample1d/DomExample1d.php","DomExample2.txt","DOM Example 5: Validation #1 (click this heading to run code)","DomExample2code.php","DomExample2.htm");
+	menulayout("../DomExample2b/DomExample2b.php","../DomExample1d/DomExample1d.php","DomExample2.txt","DOM Example 5: Validation #1 (click this heading to run code)","DomExample2code.php","DomExample2.html");
 	
 	$interestingrows=array(array(10,12,"PHP Code"),array(14,15,"PHP Code"));
 	$keywords=array('validate();','load($file);');

=== renamed file 'CodeViewer/DomExample3b/DomExample3b.htm' => 'CodeViewer/DomExample3b/DomExample3b.html'
=== modified file 'CodeViewer/DomExample3b/DomExample3b.php'
--- CodeViewer/DomExample3b/DomExample3b.php	2013-03-26 23:22:55 +0000
+++ CodeViewer/DomExample3b/DomExample3b.php	2013-04-19 09:12:11 +0000
@@ -8,7 +8,7 @@
 
 	include("../Codeviewer/showcode.php");
 	
-	menulayout("","../DomExample3/DomExample3.php","DomExample3b.txt","DOM Example 11: XPATH #2 (click this heading to run code)","DomExample3bcode.php","DomExample3b.htm");
+	menulayout("","../DomExample3/DomExample3.php","DomExample3b.txt","DOM Example 11: XPATH #2 (click this heading to run code)","DomExample3bcode.php","DomExample3b.html");
 	
 	$interestingrows=array(array(20,25,"PHP Code"));
 	$keywords=array('saveXML','loadXML','DOMXPath','query');

=== modified file 'codeigniter/application/config/routes.php'
--- codeigniter/application/config/routes.php	2013-04-10 15:49:32 +0000
+++ codeigniter/application/config/routes.php	2013-04-18 18:41:59 +0000
@@ -38,7 +38,7 @@
 |
 */
 
-$route['default_controller'] = "welcome";
+$route['default_controller'] = "home";
 $route['404_override'] = '';
 
 

=== added file 'codeigniter/application/controllers/home.php'
--- codeigniter/application/controllers/home.php	1970-01-01 00:00:00 +0000
+++ codeigniter/application/controllers/home.php	2013-04-18 18:40:36 +0000
@@ -0,0 +1,28 @@
+<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
+
+	//Home controller
+	class Home extends CI_Controller {	
+		/*
+		 *	Constructor
+		 */
+		function __construct() {
+			parent::__construct();
+			$this->load->model('user', '', TRUE);
+		}
+	
+	
+		/*
+		 *	This function runs when the user navigates directly to the home controller
+		 */
+		function index() {
+			//If the user is logged in
+			if($this->user->isLoggedIn())
+			{
+				$this->load->view('home_view');
+			} else {
+				//Redirect user to login page
+				redirect('login', 'refresh');
+			}
+		}
+	}
+?>
\ No newline at end of file

=== added file 'codeigniter/application/controllers/login.php'
--- codeigniter/application/controllers/login.php	1970-01-01 00:00:00 +0000
+++ codeigniter/application/controllers/login.php	2013-04-18 18:40:36 +0000
@@ -0,0 +1,72 @@
+<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
+
+	class Login extends CI_Controller {
+		/*
+		 *	Constructor
+		 */
+		function __construct() {
+			parent::__construct();
+			
+			//Load required library
+			$this->load->model('user', '', TRUE);
+		}
+	
+		
+		/*
+		 *	This function runs when the user navigates directly to the login controller
+		 */
+		public function index() {
+			//If user is already logged in
+			if($this->user->isLoggedIn()) {
+				//User already logged in
+				redirect('home', 'refresh');
+			} else {
+				//Display the login form
+				$this->drawLoginForm('');
+			}
+		}
+		
+		
+		/*
+		 *	This function validate the user input from login form using the library "form_validation".
+		 *  NOTICE: This does NOT mean that it validates it against the database.
+		 */
+		public function validate() {
+			//Load required library
+			$this->load->library('form_validation');
+			
+			//Sets validation rules
+			$this->form_validation->set_rules('username', 'Username', 'trim|required|xss_clean');
+			$this->form_validation->set_rules('password', 'Password', 'trim|required|xss_clean');
+			
+			//Run validation
+			if($this->form_validation->run() == FALSE) {
+				//Field validation failed. Display login form (with error message).
+				$this->drawLoginForm(validation_errors());
+			} else {
+				$username = $this->input->post('username');
+				$password = $this->input->post('password');
+				
+				//Try to login
+				if ($this->user->login($username, $password)) {
+					redirect('home', 'refresh');
+				} else {
+					$this->drawLoginForm('Access denied!');
+				}
+			}	
+		}
+		
+	
+		/*
+		 *	This function draws the login form.
+		 */
+		private function drawLoginForm($errors) {
+			//Load required library
+			$this->load->helper(array('form'));
+			
+			//Display the view
+			$data['error'] = $errors;
+			$this->load->view('login_view', $data);
+		}
+	}
+?>
\ No newline at end of file

=== added file 'codeigniter/application/controllers/logout.php'
--- codeigniter/application/controllers/logout.php	1970-01-01 00:00:00 +0000
+++ codeigniter/application/controllers/logout.php	2013-04-18 18:40:36 +0000
@@ -0,0 +1,27 @@
+<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
+
+	//Home controller
+	class Logout extends CI_Controller {	
+		/*
+		 *	Constructor
+		 */
+		function __construct() {
+			parent::__construct();
+			
+			//Load required library
+			$this->load->model('user', '', TRUE);
+		}
+	
+	
+		/*
+		 *	This function runs when the user navigates directly to the lougout controller
+		 */
+		public function index() {
+			//Perform logout
+			$this->user->logout();
+			
+			//Redirect user
+			redirect('home', 'refresh');
+		}
+	}
+?>
\ No newline at end of file

=== added file 'codeigniter/application/models/user.php'
--- codeigniter/application/models/user.php	1970-01-01 00:00:00 +0000
+++ codeigniter/application/models/user.php	2013-04-18 18:40:36 +0000
@@ -0,0 +1,102 @@
+<?php
+	Class User extends CI_Model {
+		/*
+		 *	Constructor
+		 */
+		function __construct() {
+			parent::__construct();
+			
+			//Load required libraries
+			$this->load->database();
+			$this->load->library('session');
+		}
+
+		//Queries the DB and for a matching username and password. Returns result or false.
+		/*
+		 *	Constructor
+		 */ 
+		public function login($username, $password)
+		{			
+			//Generate a salted hash
+			$hash = $this->getSaltedHash($password);
+	
+			//Query-structure
+			$this->db->select('userName, name, passwd, userType, ssn');
+			$this->db->from('Users');
+			$this->db->where('userName', $username);
+			$this->db->where('passwd', $hash);
+			$this->db->limit(1);
+			
+			//Execute query
+			$query = $this->db->get();
+			$result = $query->result();
+			
+			//If a matching DB record is found.
+			if($result) {
+				//Prepare session data
+				$userDetails = array();
+				foreach($result as $row) {
+					$userDetails = array(
+						'username' => $row->userName,
+						'name' => $row->name,
+						'usertype' => $row->userType,
+						'ssn' => $row->ssn
+					);
+				}
+				
+				//Set session data
+				$this->session->set_userdata('authenticated', $userDetails);
+				
+				//Return success
+				return TRUE;
+			} else {
+				//Return fail
+				return FALSE;
+			}	
+		}
+
+
+		/*
+		 *	This function logs the user out.
+		 */ 
+		public function logout() {		
+			//Unset session data
+			$this->session->unset_userdata('authenticated');
+		}
+		
+
+		/*
+		 *	This function return TRUE if the user is logged in and FALSE otherwise.
+		 */ 
+		public function isLoggedIn() {	
+			if ($this->session->userdata('authenticated')) {
+				return TRUE;
+			} else {
+				return FALSE;
+			}
+		}
+		
+		
+		//Generates a password hash using a user-unique salt.
+		private function getSaltedHash($pwd)
+		{	
+			/* Salt algorithm:
+			 * Step 1: Get encryption key
+			 * Step 2: Salt is set to password (reversed)
+			 * Step 3: Salt is encrypted with MD5
+			 * Step 4: Salt is reversed (again)
+			 * Step 5: Salt is encrypted with SHA1
+			 */
+			
+			$salt = '';
+			
+			//UNCOMMENT TO ACTIVATE SALT LATER IN DEVELOPMENT!!!
+			//$salt = sha1(strrev(md5(strrev($this->config->item('encryption_key')))));
+			
+			//Generate SHA1 hash using salt
+			$hash = sha1($salt.$pwd);
+			
+			return $hash;
+		}
+	}
+?>
\ No newline at end of file

=== added file 'codeigniter/application/views/home_view.php'
--- codeigniter/application/views/home_view.php	1970-01-01 00:00:00 +0000
+++ codeigniter/application/views/home_view.php	2013-04-18 18:40:36 +0000
@@ -0,0 +1,16 @@
+<!DOCTYPE HTML>
+<html xmlns="http://www.w3.org/1999/xhtml">
+	<head>
+		<title>LenaSys - Private Area</title>
+	</head>
+	<body>
+		<h1>Home</h1>
+		<h2>Welcome!</h2>
+		<a href="logout">Logout</a><br>
+		<pre>
+			<?php
+				print_r($this->session->all_userdata());
+			?>
+		</pre>
+	</body>
+</html>
\ No newline at end of file

=== added file 'codeigniter/application/views/login_view.php'
--- codeigniter/application/views/login_view.php	1970-01-01 00:00:00 +0000
+++ codeigniter/application/views/login_view.php	2013-04-18 18:40:36 +0000
@@ -0,0 +1,21 @@
+<!DOCTYPE HTML>
+<html xmlns="http://www.w3.org/1999/xhtml">
+	<head>
+		<title>LenaSys</title>
+	</head>
+	<body>
+		<h1>LenaSys</h1>
+		<div>
+		    <?php echo $error; ?>
+		</div>
+		<div>
+		    <?php echo form_open('login/validate'); ?>
+		    	<label for="username">Username:</label>
+		    	<input type="text" size="20" id="username" name="username"/><br>
+		    	<label for="password">Password:</label>
+		    	<input type="password" size="20" id="password" name="password"/><br>
+		    	<input type="submit" value="Login"/>
+		    </form>
+		</div>
+	</body>
+</html>
\ No newline at end of file

=== modified file 'databas.sql'
--- databas.sql	2013-04-17 14:22:29 +0000
+++ databas.sql	2013-04-19 09:52:40 +0000
@@ -7,19 +7,36 @@
 -- -----------------------------------------------------
 CREATE USER 'dbsk'@'localhost' IDENTIFIED BY 'Tomten2009';
 GRANT ALL PRIVILEGES ON lenasys.* TO 'dbsk'@'localhost' WITH GRANT OPTION;
+
+-- -----------------------------------------------------
+-- Table `lenasys`.`UserTypeCodes`
+-- -----------------------------------------------------
+CREATE  TABLE IF NOT EXISTS `lenasys`.`UserTypeCodes` (
+  `userTypeCode` INT NOT NULL ,
+  `userType` VARCHAR(10) NOT NULL ,
+  PRIMARY KEY (`userType`))
+ENGINE = InnoDB;
 -- -----------------------------------------------------
 -- Table `lenasys`.`Users`
 -- -----------------------------------------------------
+
 CREATE  TABLE IF NOT EXISTS `lenasys`.`Users` (
   `userName` VARCHAR(20) NOT NULL ,
   `name` VARCHAR(45) NULL ,
-  `passwd` VARCHAR(45) NULL ,
-  `userType` INT NULL , -- teacher or student
+  `passwd` CHAR(40) NULL ,
+  `userType` INT NULL , -- 0=teacher or 1=student
   `ssn` CHAR(13) NULL COMMENT 'yyyymmdd-xxxx' ,
   PRIMARY KEY (`userName`) ,
-  UNIQUE INDEX `userName_UNIQUE` (`userName` ASC) )
+  UNIQUE INDEX `userName_UNIQUE` (`userName` ASC),
+  INDEX `fk_Users_UserTypeCodes1_idx` (`userType` ASC) ,
+  CONSTRAINT `fk_Users_usertypeCodes1`
+    FOREIGN KEY (`userType` )
+    REFERENCES `lenasys`.`userTypeCodes` (`userTypeCode` )
+    ON DELETE NO ACTION
+    ON UPDATE NO ACTION)
 ENGINE = InnoDB;
 
+
 -- -----------------------------------------------------
 -- Table `lenasys`.`Courses`
 -- -----------------------------------------------------
@@ -229,12 +246,79 @@
     ON DELETE NO ACTION
     ON UPDATE NO ACTION)
 ENGINE = InnoDB;
--- -------------------------------------------------
+
+
+-- -----------------------------------------------------
+-- Table `lenasys`.`logUsersQuizLogins`
+-- -----------------------------------------------------
+CREATE  TABLE IF NOT EXISTS `lenasys`.`logUsersQuizLogins` (
+  `id` INT NOT NULL ,
+  `userName` VARCHAR(20) NOT NULL ,
+  `userAgent` VARCHAR(20) /*NOT NULL*/ ,
+  `userIP` VARCHAR(20) /*NOT NULL*/ ,
+  `browserID` VARCHAR(20) /*NOT NULL*/ ,
+  `courseID` VARCHAR(10) NOT NULL ,
+  `courseOccasion` VARCHAR(16) NULL ,
+  `quizNr` INT NOT NULL ,
+  `loginTimeStamp` DATETIME NOT NULL ,
+  `success` VARCHAR(20) NOT NULL , -- Boolean?
+  PRIMARY KEY (`id`) ,
+  UNIQUE INDEX `id_UNIQUE` (`id` ASC))
+ENGINE = InnoDB;
+-- -------------------------------------------------
+-- Table `lenasys`.`logAssignedQuizzesAnswers`
+-- -----------------------------------------------------
+CREATE  TABLE IF NOT EXISTS `lenasys`.`logUsersQuizLogins` (
+  `id` INT NOT NULL ,
+  `userName` VARCHAR(20)  NOT NULL ,
+  `userAgent` VARCHAR(20) /*NOT NULL*/ ,
+  `userIP` VARCHAR(20) /*NOT NULL*/ ,
+  `courseID` VARCHAR(10) NOT NULL ,
+  `courseOccasion` VARCHAR(16) NOT NULL ,
+  `quizNr` INT NOT NULL ,
+  `answers` VARCHAR(45) NULL ,
+  `answerHash` VARCHAR(45) NULL ,
+  `answeredTimeStamp` DATETIME NULL ,
+  `grade` VARCHAR(8) NULL ,
+  `gradeComment` VARCHAR(200) NULL ,
+  PRIMARY KEY (`id`) ,
+    UNIQUE INDEX `id_UNIQUE` (`id` ASC))
+
+ENGINE = InnoDB;
+-- -------------------------------------------------
+-- Table `lenasys`.`logBenchmark`
+-- -----------------------------------------------------
+CREATE  TABLE IF NOT EXISTS `lenasys`.`logUsersQuizLogins` (
+  `id` INT NOT NULL ,
+  `userName` VARCHAR(20) NOT NULL ,
+  `userAgent` VARCHAR(20) /*NOT NULL*/ ,
+  `userIP` VARCHAR(20)  /*NOT NULL*/ ,
+  `browser` VARCHAR(20)  /*NOT NULL*/ ,
+  `browserVersion` VARCHAR(20) /*NOT NULL*/ ,
+  `renderer` VARCHAR(20) /*NOT NULL*/ ,
+  `rendererVersion` VARCHAR(20) /*NOT NULL*/ ,
+  `os` VARCHAR(20) /*NOT NULL*/ ,
+  `osVersion` VARCHAR(20) /*NOT NULL*/ ,
+  `fps` VARCHAR(20) /*NOT NULL*/ ,
+  `maxFps` VARCHAR(20) /*NOT NULL*/ ,
+  -- `host` INT /*NOT NULL*/ ,
+  `app` INT /*NOT NULL*/ ,
+  `screenResolution` VARCHAR(20) /*NOT NULL*/ ,
+  `logTimeStamp` DATETIME /*NOT NULL*/ ,
+  `runtime` VARCHAR(20) /*NOT NULL*/ ,
+  PRIMARY KEY (`id`) ,
+    UNIQUE INDEX `id_UNIQUE` (`id` ASC))
+ENGINE = InnoDB;
+-- -------------------------------------------------
+
 insert into `lenasys`.`Users` (`userName`,`name`,`passwd`,`userType`,`ssn`) 
-  VALUES ('Per','Per Student',md5('Syp9393'),1,'19900385-2345');
-
-USE `lenasys` ;
-
+  VALUES ('sha1','Per Student',sha1('Syp9393'),1,'19900385-2345'),
+  ('md5','Per Lrare',md5('Syp9393'),0,'19800385-2325');
+  
+  insert into `lenasys`.`UserTypeCodes` (`userTypeCode`,`userType`) 
+  VALUES (0,'Teacher'),(1,'Student');
+
+-- -----------------------------------------------------
 -- allow maximum of 5 succesfull quiz-attemps is a good begining for implementation of the loggingtables to add restriction. 
 SET SQL_MODE=@OLD_SQL_MODE;
 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;

